Bug 34882 (Special-Character) - Special character dialog rework (comment 28 for scope)
Summary: Special character dialog rework (comment 28 for scope)
Status: NEW
Alias: Special-Character
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Not Assigned
QA Contact:
URL: http://user-prompt.com/libreoffice-de...
Whiteboard: target:5.1.0 target:5.2.0 target:5.1.2
Keywords: difficultyBeginner, easyHack, skillCpp, topicUI
: 77689 84077 86419 90571 98250 100688 101516 (view as bug list)
Depends on: 53299
Blocks: Dialog
  Show dependency treegraph
 
Reported: 2011-03-01 12:36 UTC by Roman Stingler
Modified: 2017-05-22 02:16 UTC (History)
22 users (show)

See Also:
Crash report or crash signature:


Attachments
Patch for hex and decimal code search (12.54 KB, patch)
2015-07-05 05:36 UTC, Steve Hart
Details
gnome character map (73.52 KB, image/png)
2016-02-29 18:25 UTC, Yousuf Philips (jay)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Roman Stingler 2011-03-01 12:36:22 UTC
it would be nice to have 2 rows filled with the latest used special characters.
Comment 1 Cédric Bosdonnat 2011-03-02 02:31:27 UTC
Indeed that would be a nice feature.

A nice starting point in the code is:
http://opengrok.libreoffice.org/s?refs=SvxCharacterMap
Comment 2 Björn Michaelsen 2011-12-23 11:46:36 UTC Comment hidden (obsolete)
Comment 3 Björn Michaelsen 2011-12-23 12:57:25 UTC
An EasyHack should have been checked by developers and thus is confirmed regardless of age. Moving back to NEW from NEEDINFO again. Sorry for the hassle.
Comment 4 Florian Reisinger 2012-05-18 09:41:49 UTC
Deleted "Easyhack" from summary.
Comment 5 Björn Michaelsen 2013-10-04 18:47:01 UTC
adding LibreOffice developer list as CC to unresolved EasyHacks for better visibility.

see e.g. http://nabble.documentfoundation.org/minutes-of-ESC-call-td4076214.html for details
Comment 6 Adolfo Jayme 2015-03-04 07:51:31 UTC
*** Bug 86419 has been marked as a duplicate of this bug. ***
Comment 7 Adolfo Jayme 2015-03-04 07:54:29 UTC
*** Bug 77689 has been marked as a duplicate of this bug. ***
Comment 8 Adolfo Jayme 2015-03-04 07:59:38 UTC
*** Bug 84077 has been marked as a duplicate of this bug. ***
Comment 9 Yousuf Philips (jay) 2015-03-14 20:42:09 UTC
A believe a special character split/group button would be the better approach, as it is used in other word processors.

MS Word - http://i.imgur.com/GiyojNv.png
WPS Writer - http://i.imgur.com/05A02N9.png
Wordperfect - http://i.imgur.com/gsxv8a3.png
Comment 10 A (Andy) 2015-03-26 18:42:49 UTC
(In reply to Jay Philips from comment #9)
> A believe a special character split/group button would be the better
> approach, as it is used in other word processors.
> 
> MS Word - http://i.imgur.com/GiyojNv.png
> WPS Writer - http://i.imgur.com/05A02N9.png
> Wordperfect - http://i.imgur.com/gsxv8a3.png

I think this would be nice and good.
Comment 11 Yousuf Philips (jay) 2015-03-27 08:24:10 UTC
A design session happened last friday about this and details can be found at the following google doc.

https://docs.google.com/document/d/1PxkIpkzgWF1cX9oQmBhjiTBhUXvUEqbz06Bn4hzbF54/edit?usp=sharing

It has also been published on user-prompt for users to comment.

http://user-prompt.com/libreoffice-design-session-special-character/
Comment 12 Steve Hart 2015-07-03 22:48:34 UTC
I'm starting to work on this. It's the first time I've worked on the LibreOffice code, so I don't know how far I'll get, but I'll post updates on how it's going.
Comment 13 Steve Hart 2015-07-05 05:36:16 UTC
Created attachment 117051 [details]
Patch for hex and decimal code search

Here's a patch for what I've done so far. I have the hex and decimal code search functionality working. Is there a recommended behavior for how to handle codes for characters that are not available? Currently, I am just ignoring them, but I think there must be a better way so that the user knows what the problem is.
Comment 14 tommy27 2015-07-05 07:32:26 UTC
I think it's better you submit your patch this way:
https://wiki.documentfoundation.org/Development/gerrit/SubmitPatch
Comment 15 Yousuf Philips (jay) 2015-11-12 16:29:17 UTC
@Steve: I've pushed your patch into gerrit, though it didnt compile correctly due to new changes in the code.

https://gerrit.libreoffice.org/19935
Comment 16 Steve Hart 2015-11-15 18:49:22 UTC
@Yousuf: I will try to take a look at it, but probably won't have a chance until mid- to late-December. There was still more work that I was going to do on this, but haven't had time in a while.

If there is anyone who would like to work on this in the meantime, feel free to assign it to yourself.

Also, my license statement is at http://lists.freedesktop.org/archives/libreoffice/2015-August/069681.html
Comment 17 Commit Notification 2015-11-17 14:22:16 UTC
Steve Hart committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=1b9956c2b150c37cf0e695f88bc0394f41d130a2

tdf#34882 Adding hex and decimal code search

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 18 Robinson Tryon (qubit) 2015-12-14 06:37:20 UTC
Migrating Whiteboard tags to Keywords: (EasyHack DifficultyBeginner SkillCpp TopicUi)
[NinjaEdit]
Comment 19 Commit Notification 2016-01-07 18:05:14 UTC
Adolfo Jayme Barrientos committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=1f4751491b38196d0a246c135349bdd42aba28f1

tdf#34882 Harmonize alignment of hex./decimal boxes

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 20 jani 2016-02-17 07:17:20 UTC
Steve@ A polite ping, are you still working on this ?
Comment 21 Chris Sherlock 2016-02-17 09:00:47 UTC
I think this one has been done, it just needs someone to test it to ensure it's correct.
Comment 22 jani 2016-02-17 09:57:07 UTC
OK, moving it to QA for testing.
Comment 23 Yousuf Philips (jay) 2016-02-17 13:25:23 UTC
This hasnt been fully completed, as Steve only did one aspect of the redesign of the symbol dialog. See comment 11 and link below.

https://wiki.documentfoundation.org/Development/GSoC/Ideas#Special_characters_dialog

It would be good to push Adolfo's comment 19 patch into 5.1.
Comment 24 Steve Hart 2016-02-17 13:37:29 UTC
Yousuf is right about the current patch only partially implementing the requested features. I have unassigned myself to the bug, since I am no longer working on it.
Comment 25 Commit Notification 2016-02-18 09:41:53 UTC
Adolfo Jayme Barrientos committed a patch related to this issue.
It has been pushed to "libreoffice-5-1":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=2b45d15bab35830444bff6ec29c9f37a320f6367&h=libreoffice-5-1

tdf#34882 Harmonize alignment of hex./decimal boxes

It will be available in 5.1.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 26 Yousuf Philips (jay) 2016-02-21 02:26:37 UTC
*** Bug 90571 has been marked as a duplicate of this bug. ***
Comment 27 Yousuf Philips (jay) 2016-02-28 15:49:54 UTC
*** Bug 98250 has been marked as a duplicate of this bug. ***
Comment 28 V Stuart Foote 2016-02-28 16:31:54 UTC
Added URL for the Design session blog -- 

http://user-prompt.com/libreoffice-design-session-special-character/

Issue/Problem as extracted:

-* There is no way to quickly re-use recently-picked special characters, forcing the user to search in the whole character map, which has no filter to narrow down results.

-* People writing scientific/legal essays or reports frequently need to insert accented letters and other characters.

-* Technical POV to special characters (alignment 15 by 15) instead of natural organization

-* The subset is limited by presetting a special font (some chars cannot be found when the wrong font is set-up)

-* Search function is missing (should be available for name, id, symbol…)

-* Weird interaction with selection first followed by copy/paste from Characters

-* No individualization like store last subset, or define ‘my own subset’
Comment 29 Yousuf Philips (jay) 2016-02-29 18:25:07 UTC
Created attachment 123083 [details]
gnome character map

Bug 98250 suggested we display the unicode character name in the dialog, similar to how it is in the screenshot. The full unicode character information is scheduled to be displayed in the extended mockup within a tooltip.

The unicode character name can be pulled from either of these sources.
http://www.unicode.org/Public/UNIDATA/UnicodeData.txt
http://www.unicode.org/Public/UNIDATA/NamesList.txt
Comment 30 Dennis Roczek 2016-05-17 00:43:08 UTC
just for the reference (as i found it by accident) this feature request is listed since ages at https://wiki.documentfoundation.org/Development/Really_basic_missing_features_and_enhancements#Insert_Special_Characters_-.3E_Recent_Characters_tdf.2334882
Comment 31 V Stuart Foote 2016-06-30 17:22:11 UTC
*** Bug 100688 has been marked as a duplicate of this bug. ***
Comment 32 Yan Pas 2016-09-07 08:11:23 UTC
Which class(es) does LO use for persisntent storage? I should store these symbols somewhere in cache
Comment 33 V Stuart Foote 2016-09-15 15:13:33 UTC
*** Bug 101516 has been marked as a duplicate of this bug. ***
Comment 34 V Stuart Foote 2016-09-15 15:17:07 UTC
Nice mockup from Óvári in dupe bug 101516

attachment 126826 [details]
Comment 35 Federico Bassini 2016-10-10 14:01:32 UTC
i'm interessed to resolve this easyhack!

but i have a lot of question to start:

is there a website/wiki/.. to view how is the logic of the code?
which are the files to modify a dialog?
is there a IDE to draw the layout of dialog? if not, how to code this?
which is the file that contain the code dialog functions?

in a while i'll try to read the patchs just merged...

i'm new and i'm intersting to learn about how is contruct the code of libreOffice

(i don't know if exists a channel to comunicate with anyone to discuss the logic of libreoffice!)

thanks!
Comment 36 Yousuf Philips (jay) 2016-10-10 17:47:18 UTC
(In reply to Federico Bassini from comment #35)
> is there a website/wiki/.. to view how is the logic of the code?

You can view the code on git or on the live repo.

https://cgit.freedesktop.org/libreoffice/core/

> which are the files to modify a dialog?

https://cgit.freedesktop.org/libreoffice/core/tree/cui/uiconfig/ui/specialcharacters.ui

> is there a IDE to draw the layout of dialog? if not, how to code this?
> which is the file that contain the code dialog functions?

The dialog is designed with the glade editor.

https://glade.gnome.org/

> i'm new and i'm intersting to learn about how is contruct the code of
> libreOffice

Glad to have you on board.

> (i don't know if exists a channel to comunicate with anyone to discuss the
> logic of libreoffice!)

You can join the #libreoffice-design and #libreoffice-dev channels on freenode for people to discuss the issue with.
Comment 37 jani 2016-11-14 10:16:20 UTC
A polite ping, still working on this bug ?
Comment 38 Federico Bassini 2016-11-23 09:21:58 UTC
yes, i'm work on it!
Comment 39 jani 2016-12-24 08:25:22 UTC
(In reply to Federico Bassini from comment #38)
> yes, i'm work on it!

Another polite ping :-)
Comment 40 Federico Bassini 2016-12-25 17:24:08 UTC
(In reply to jan iversen from comment #39)
> (In reply to Federico Bassini from comment #38)
> > yes, i'm work on it!
> 
> Another polite ping :-)

yes i'm work and submit a patch! 
https://gerrit.libreoffice.org/#/c/32224/
i need some help... i comment on it! :)
Comment 41 jani 2017-01-25 07:17:34 UTC
(In reply to Federico Bassini from comment #40)
> (In reply to jan iversen from comment #39)
> > (In reply to Federico Bassini from comment #38)
> > > yes, i'm work on it!
> > 
> > Another polite ping :-)
> 
> yes i'm work and submit a patch! 
> https://gerrit.libreoffice.org/#/c/32224/
> i need some help... i comment on it! :)
And the patch contains a response to what you need.
Comment 42 Marco A.G.Pinto 2017-04-20 13:49:30 UTC
I have installed 5.4 alpha and it still doesn't have a StringGadget "Recently used symbols" like MS Word does.
Comment 43 V Stuart Foote 2017-04-20 14:11:58 UTC
(In reply to Marco A.G.Pinto from comment #42)
> I have installed 5.4 alpha and it still doesn't have a StringGadget
> "Recently used symbols" like MS Word does.

@Federico, are you still working on your patch [1]? Or should its work be abandoned and this issue unassigned?

=-ref-=
[1] https://gerrit.libreoffice.org/#/c/32224/
Comment 44 Xisco Faulí 2017-05-21 09:05:21 UTC
A polite ping, still working on this bug
Comment 45 Yousuf Philips (jay) 2017-05-21 15:57:17 UTC
(In reply to Xisco Faulí from comment #44)
> A polite ping, still working on this bug

Akshay is taking this on as a GSoC project.

https://design.blog.documentfoundation.org/2017/05/06/welcome-gsoc17-students/